#include "effects/dvd.h"
#include "my_fastled.h"

void DvdEffect::loop(uint16_t ms) {
	bool dir_changed = false;
	
	_x += _x_dir * settings.effects.dvd.speed;
	_y += _y_dir * settings.effects.dvd.speed;

	if (_x <= 0) {
		_x = -_x;
		_x_dir = -_x_dir;
		dir_changed = true;
		//LOGln("speed: %d", settings.effects.dvd.speed);
	} else if (_x + (settings.effects.dvd.width << 8) >= (window->width << 8)) {
		_x -= 2*settings.effects.dvd.speed;
		_x_dir = -_x_dir;
		dir_changed = true;
	}
	
	if (_y <= 0) {
		_y = -_y;
		_y_dir = -_y_dir;
		dir_changed = true;
	} else if (_y + (settings.effects.dvd.height << 8) >= (window->height << 8)) {
		_y -= 2*settings.effects.dvd.speed;
		_y_dir = -_y_dir;
		dir_changed = true;
	}

	window->clear();
	
	if (dir_changed) _color = (CRGB)CHSV(random8(), 255, 255);

	for (int x=0; x<settings.effects.dvd.width; x++) for (int y=0; y<settings.effects.dvd.height; y++) {
		window->setSubPixel(_x + (x<<8), _y + (y<<8), (CRGB*)&_color);
	}
	for (int x=1; x<settings.effects.dvd.width; x++) for (int y=1; y<settings.effects.dvd.height; y++) {
		window->setPixel((_x>>8) + x, (_y>>8) + y, (CRGB*)&_color);
	}
}

bool DvdEffect::can_be_shown_with_clock() { return true; }

DvdEffect::DvdEffect() {
	_color = CHSV(random8(), 255, 255);
}

DvdEffect::~DvdEffect() {
}
