#include <Arduino.h>
#include "my_wifi.h"
#include "config.h"


void wifi_setup() {
	WiFi.mode(WIFI_STA);
	WiFi.begin(WIFI_SSID, WIFI_PASS);
	uint8_t result;
	uint8_t counter = 0;
	while ((result = WiFi.waitForConnectResult()) != WL_CONNECTED) {
		counter++;
		if (counter > 100) {
			Serial.print("WiFi * Connection Failed! Last result was: ");
			Serial.print(result);
			Serial.println(" Rebooting...");
			delay(100);
			ESP.restart();
		}
		Serial.print("WiFi * Still waiting for WiFi to connect. This is loop number ");
		Serial.println(counter);
		delay(100);
	}
	Serial.println("WiFi * Ready");
	Serial.print("WiFi * IP address: ");
	Serial.println(WiFi.localIP());
}
